<?php
namespace Modules\Parametro\Services;

use Zeedhi\Framework\DTO;


class Gop00100ParametroOrcamentoOperacionalService {
    protected $connection;
    
    public function __construct($connection, $environment){
        $this->connection   = $connection;
        $this->environment  = $environment;
    }
    
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
        $this->connection->rollback();
    }
    
    public function updateOrcamento($params) {
        $sqlUpdate =  "UPDATE ITEMOPERACIONAL
                          SET IDCHECK = :P_IDCHECK
                        WHERE NRITEMOPERACIONAL = :P_NRITEMOPERACIONAL";
        
        try{
            $stmt = $this->connection->prepare($sqlUpdate);
            $retorno = $stmt->execute($params);
            return $retorno;
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function insertItensOp($params) {
        $sqlInsert =   "INSERT INTO ITEMOPERACIONAL (
                        NRITEMOPERACIONAL,
                        IDTIPOORCAOP,
                        IDCHECK
                        ) VALUES (
                        :P_NRITEMOPERACIONAL,
                        :P_IDTIPOORCAOP,
                        :P_IDCHECK
                        )";
        try{
            $stmt = $this->connection->prepare($sqlInsert);
            $retorno = $stmt->execute($params);
            return $retorno;
        }catch(Exception $e) {
            throw $e;
        }
    }
}